Index: trunk/sources/HeuristicLab.Persistence/3.3/Default/DebugString/DebugStringFormat.cs
===================================================================
--- trunk/sources/HeuristicLab.Persistence/3.3/Default/DebugString/DebugStringFormat.cs	(revision 3017)
+++ trunk/sources/HeuristicLab.Persistence/3.3/Default/DebugString/DebugStringFormat.cs	(revision 3036)
@@ -10,6 +10,13 @@
 namespace HeuristicLab.Persistence.Default.DebugString {
 
+  /// <summary>
+  /// Simple write-only format for debugging purposes.
+  /// </summary>
   [StorableClass]
   public class DebugStringFormat : FormatBase<DebugString> {
+    /// <summary>
+    /// Gets the format's name.
+    /// </summary>
+    /// <value>The format's name.</value>
     public override string Name { get { return "DebugString"; } }
   }
Index: trunk/sources/HeuristicLab.Persistence/3.3/Default/DebugString/DebugStringGenerator.cs
===================================================================
--- trunk/sources/HeuristicLab.Persistence/3.3/Default/DebugString/DebugStringGenerator.cs	(revision 3017)
+++ trunk/sources/HeuristicLab.Persistence/3.3/Default/DebugString/DebugStringGenerator.cs	(revision 3036)
@@ -9,4 +9,7 @@
 namespace HeuristicLab.Persistence.Default.DebugString {
 
+  /// <summary>
+  /// Generate a string that recursively describes an object graph.
+  /// </summary>
   public class DebugStringGenerator : GeneratorBase<string> {
 
@@ -14,6 +17,13 @@
     private readonly bool showRefs;
 
+    /// <summary>
+    /// Initializes a new instance of the <see cref="DebugStringGenerator"/> class.
+    /// </summary>
     public DebugStringGenerator() : this(true) { }
 
+    /// <summary>
+    /// Initializes a new instance of the <see cref="DebugStringGenerator"/> class.
+    /// </summary>
+    /// <param name="showRefs">if set to <c>true</c> show references.</param>
     public DebugStringGenerator(bool showRefs) {
       isSepReq = false;
@@ -21,4 +31,9 @@
     }
 
+    /// <summary>
+    /// Formats the specified begin token.
+    /// </summary>
+    /// <param name="beginToken">The begin token.</param>
+    /// <returns>The token in serialized form.</returns>
     protected override string Format(BeginToken beginToken) {
       StringBuilder sb = new StringBuilder();
@@ -38,4 +53,9 @@
     }
 
+    /// <summary>
+    /// Formats the specified end token.
+    /// </summary>
+    /// <param name="endToken">The end token.</param>
+    /// <returns>The token in serialized form.</returns>
     protected override string Format(EndToken endToken) {
       isSepReq = true;
@@ -43,4 +63,9 @@
     }
 
+    /// <summary>
+    /// Formats the specified primitive token.
+    /// </summary>
+    /// <param name="primitiveToken">The primitive token.</param>
+    /// <returns>The token in serialized form.</returns>
     protected override string Format(PrimitiveToken primitiveToken) {
       StringBuilder sb = new StringBuilder();
@@ -61,4 +86,9 @@
     }
 
+    /// <summary>
+    /// Formats the specified reference token.
+    /// </summary>
+    /// <param name="referenceToken">The reference token.</param>
+    /// <returns>The token in serialized form.</returns>
     protected override string Format(ReferenceToken referenceToken) {
       StringBuilder sb = new StringBuilder();
@@ -76,4 +106,9 @@
     }
 
+    /// <summary>
+    /// Formats the specified null reference token.
+    /// </summary>
+    /// <param name="nullReferenceToken">The null reference token.</param>
+    /// <returns>The token in serialized form.</returns>
     protected override string Format(NullReferenceToken nullReferenceToken) {
       StringBuilder sb = new StringBuilder();
@@ -89,20 +124,46 @@
     }
 
+    /// <summary>
+    /// Formats the specified meta info begin token.
+    /// </summary>
+    /// <param name="metaInfoBeginToken">The meta info begin token.</param>
+    /// <returns>The token in serialized form.</returns>
     protected override string Format(MetaInfoBeginToken metaInfoBeginToken) {
       return "[";
     }
 
+    /// <summary>
+    /// Formats the specified meta info end token.
+    /// </summary>
+    /// <param name="metaInfoEndToken">The meta info end token.</param>
+    /// <returns>The token in serialized form.</returns>
     protected override string Format(MetaInfoEndToken metaInfoEndToken) {
       return "]";
     }
 
+    /// <summary>
+    /// Formats the specified type token.
+    /// </summary>
+    /// <param name="typeToken">The type token.</param>
+    /// <returns>The token in serialized form.</returns>
     protected override string Format(TypeToken typeToken) {
       return string.Empty;
     }
 
+    /// <summary>
+    /// Serializes the specified object.
+    /// </summary>
+    /// <param name="o">The object.</param>
+    /// <returns>A string representation of the complete object graph</returns>
     public static string Serialize(object o) {
       return Serialize(o, ConfigurationService.Instance.GetDefaultConfig(new DebugStringFormat()));
     }
 
+    /// <summary>
+    /// Serializes the specified object.
+    /// </summary>
+    /// <param name="o">The object.</param>
+    /// <param name="configuration">The persistence configuration.</param>
+    /// <returns>A string representation of the complete object graph.</returns>
     public static string Serialize(object o, Configuration configuration) {
       Serializer s = new Serializer(o, configuration);
Index: trunk/sources/HeuristicLab.Persistence/3.3/Default/DebugString/PrimitiveSerializers/Bool2DebugStringSerializer.cs
===================================================================
--- trunk/sources/HeuristicLab.Persistence/3.3/Default/DebugString/PrimitiveSerializers/Bool2DebugStringSerializer.cs	(revision 3017)
+++ trunk/sources/HeuristicLab.Persistence/3.3/Default/DebugString/PrimitiveSerializers/Bool2DebugStringSerializer.cs	(revision 3036)
@@ -9,5 +9,5 @@
 namespace HeuristicLab.Persistence.Default.DebugString.PrimitiveSerializers {
 
-  public class Bool2DebugStringSerializer : DebugStringSerializerBase<bool> { }
+  internal sealed class Bool2DebugStringSerializer : DebugStringSerializerBase<bool> { }
 
 }
Index: trunk/sources/HeuristicLab.Persistence/3.3/Default/DebugString/PrimitiveSerializers/Byte2DebugStringSerializer.cs
===================================================================
--- trunk/sources/HeuristicLab.Persistence/3.3/Default/DebugString/PrimitiveSerializers/Byte2DebugStringSerializer.cs	(revision 3017)
+++ trunk/sources/HeuristicLab.Persistence/3.3/Default/DebugString/PrimitiveSerializers/Byte2DebugStringSerializer.cs	(revision 3036)
@@ -9,5 +9,5 @@
 namespace HeuristicLab.Persistence.Default.DebugString.PrimitiveSerializers {
 
-  public class Byte2DebugStringSerializer : DebugStringSerializerBase<byte> { }
+  internal sealed class Byte2DebugStringSerializer : DebugStringSerializerBase<byte> { }
 
 }
Index: trunk/sources/HeuristicLab.Persistence/3.3/Default/DebugString/PrimitiveSerializers/Char2DebugStringSerializer.cs
===================================================================
--- trunk/sources/HeuristicLab.Persistence/3.3/Default/DebugString/PrimitiveSerializers/Char2DebugStringSerializer.cs	(revision 3017)
+++ trunk/sources/HeuristicLab.Persistence/3.3/Default/DebugString/PrimitiveSerializers/Char2DebugStringSerializer.cs	(revision 3036)
@@ -9,5 +9,5 @@
 namespace HeuristicLab.Persistence.Default.DebugString.PrimitiveSerializers {
 
-  public class Char2DebugStringSerializer : DebugStringSerializerBase<char> { }
+  internal sealed class Char2DebugStringSerializer : DebugStringSerializerBase<char> { }
 
 }
Index: trunk/sources/HeuristicLab.Persistence/3.3/Default/DebugString/PrimitiveSerializers/DateTime2DebugStringSerializer.cs
===================================================================
--- trunk/sources/HeuristicLab.Persistence/3.3/Default/DebugString/PrimitiveSerializers/DateTime2DebugStringSerializer.cs	(revision 3017)
+++ trunk/sources/HeuristicLab.Persistence/3.3/Default/DebugString/PrimitiveSerializers/DateTime2DebugStringSerializer.cs	(revision 3036)
@@ -9,5 +9,5 @@
 namespace HeuristicLab.Persistence.Default.DebugString.PrimitiveSerializers {
 
-  public class DateTime2DebugStringSerializer : DebugStringSerializerBase<DateTime> { }
+  internal sealed class DateTime2DebugStringSerializer : DebugStringSerializerBase<DateTime> { }
 
 }
Index: trunk/sources/HeuristicLab.Persistence/3.3/Default/DebugString/PrimitiveSerializers/Double2DebugStringSerializer.cs
===================================================================
--- trunk/sources/HeuristicLab.Persistence/3.3/Default/DebugString/PrimitiveSerializers/Double2DebugStringSerializer.cs	(revision 3017)
+++ trunk/sources/HeuristicLab.Persistence/3.3/Default/DebugString/PrimitiveSerializers/Double2DebugStringSerializer.cs	(revision 3036)
@@ -9,5 +9,5 @@
 namespace HeuristicLab.Persistence.Default.DebugString.PrimitiveSerializers {
 
-  public class Double2DebugStringSerializer : DebugStringSerializerBase<double> { }
+  internal sealed class Double2DebugStringSerializer : DebugStringSerializerBase<double> { }
 
 }
Index: trunk/sources/HeuristicLab.Persistence/3.3/Default/DebugString/PrimitiveSerializers/Float2DebugStringSerializer.cs
===================================================================
--- trunk/sources/HeuristicLab.Persistence/3.3/Default/DebugString/PrimitiveSerializers/Float2DebugStringSerializer.cs	(revision 3017)
+++ trunk/sources/HeuristicLab.Persistence/3.3/Default/DebugString/PrimitiveSerializers/Float2DebugStringSerializer.cs	(revision 3036)
@@ -9,5 +9,5 @@
 namespace HeuristicLab.Persistence.Default.DebugString.PrimitiveSerializers {
 
-  public class Float2DebugStringSerializer : DebugStringSerializerBase<float> { }
+  internal sealed class Float2DebugStringSerializer : DebugStringSerializerBase<float> { }
 
 }
Index: trunk/sources/HeuristicLab.Persistence/3.3/Default/DebugString/PrimitiveSerializers/Int2DebugStringSerializer.cs
===================================================================
--- trunk/sources/HeuristicLab.Persistence/3.3/Default/DebugString/PrimitiveSerializers/Int2DebugStringSerializer.cs	(revision 3017)
+++ trunk/sources/HeuristicLab.Persistence/3.3/Default/DebugString/PrimitiveSerializers/Int2DebugStringSerializer.cs	(revision 3036)
@@ -9,5 +9,5 @@
 namespace HeuristicLab.Persistence.Default.DebugString.PrimitiveSerializers {
 
-  public class Int2DebugStringSerializer : DebugStringSerializerBase<int> { }
+  internal sealed class Int2DebugStringSerializer : DebugStringSerializerBase<int> { }
 
 }
Index: trunk/sources/HeuristicLab.Persistence/3.3/Default/DebugString/PrimitiveSerializers/Long2DebugStringSerializer.cs
===================================================================
--- trunk/sources/HeuristicLab.Persistence/3.3/Default/DebugString/PrimitiveSerializers/Long2DebugStringSerializer.cs	(revision 3017)
+++ trunk/sources/HeuristicLab.Persistence/3.3/Default/DebugString/PrimitiveSerializers/Long2DebugStringSerializer.cs	(revision 3036)
@@ -9,5 +9,5 @@
 namespace HeuristicLab.Persistence.Default.DebugString.PrimitiveSerializers {
 
-  public class Long2DebugStringSerializer : DebugStringSerializerBase<long> { }
+  internal sealed class Long2DebugStringSerializer : DebugStringSerializerBase<long> { }
 
 }
Index: trunk/sources/HeuristicLab.Persistence/3.3/Default/DebugString/PrimitiveSerializers/SByte2DebugStringSerializer.cs
===================================================================
--- trunk/sources/HeuristicLab.Persistence/3.3/Default/DebugString/PrimitiveSerializers/SByte2DebugStringSerializer.cs	(revision 3017)
+++ trunk/sources/HeuristicLab.Persistence/3.3/Default/DebugString/PrimitiveSerializers/SByte2DebugStringSerializer.cs	(revision 3036)
@@ -9,5 +9,5 @@
 namespace HeuristicLab.Persistence.Default.DebugString.PrimitiveSerializers {
 
-  public class SByte2DebugStringSerializer : DebugStringSerializerBase<sbyte> { }
+  internal sealed class SByte2DebugStringSerializer : DebugStringSerializerBase<sbyte> { }
 
 }
Index: trunk/sources/HeuristicLab.Persistence/3.3/Default/DebugString/PrimitiveSerializers/Short2DebugStringSerializer.cs
===================================================================
--- trunk/sources/HeuristicLab.Persistence/3.3/Default/DebugString/PrimitiveSerializers/Short2DebugStringSerializer.cs	(revision 3017)
+++ trunk/sources/HeuristicLab.Persistence/3.3/Default/DebugString/PrimitiveSerializers/Short2DebugStringSerializer.cs	(revision 3036)
@@ -9,5 +9,5 @@
 namespace HeuristicLab.Persistence.Default.DebugString.PrimitiveSerializers {
 
-  public class Short2DebugStringSerializer : DebugStringSerializerBase<short> { }
+  internal sealed class Short2DebugStringSerializer : DebugStringSerializerBase<short> { }
 
 }
Index: trunk/sources/HeuristicLab.Persistence/3.3/Default/DebugString/PrimitiveSerializers/String2DebugStringSerializer.cs
===================================================================
--- trunk/sources/HeuristicLab.Persistence/3.3/Default/DebugString/PrimitiveSerializers/String2DebugStringSerializer.cs	(revision 3017)
+++ trunk/sources/HeuristicLab.Persistence/3.3/Default/DebugString/PrimitiveSerializers/String2DebugStringSerializer.cs	(revision 3036)
@@ -9,5 +9,5 @@
 namespace HeuristicLab.Persistence.Default.DebugString.PrimitiveSerializers {
 
-  public class String2DebugStringSerializer : DebugStringSerializerBase<string> { }
+  internal sealed class String2DebugStringSerializer : DebugStringSerializerBase<string> { }
 
 }
Index: trunk/sources/HeuristicLab.Persistence/3.3/Default/DebugString/PrimitiveSerializers/Type2DebugStringSerializer.cs
===================================================================
--- trunk/sources/HeuristicLab.Persistence/3.3/Default/DebugString/PrimitiveSerializers/Type2DebugStringSerializer.cs	(revision 3017)
+++ trunk/sources/HeuristicLab.Persistence/3.3/Default/DebugString/PrimitiveSerializers/Type2DebugStringSerializer.cs	(revision 3036)
@@ -9,5 +9,5 @@
 namespace HeuristicLab.Persistence.Default.DebugString.PrimitiveSerializers {
 
-  public class Type2DebugStringSerializer : DebugStringSerializerBase<Type> { }
+  internal sealed class Type2DebugStringSerializer : DebugStringSerializerBase<Type> { }
 
 }
Index: trunk/sources/HeuristicLab.Persistence/3.3/Default/DebugString/PrimitiveSerializers/UInt2DebugStringSerializer.cs
===================================================================
--- trunk/sources/HeuristicLab.Persistence/3.3/Default/DebugString/PrimitiveSerializers/UInt2DebugStringSerializer.cs	(revision 3017)
+++ trunk/sources/HeuristicLab.Persistence/3.3/Default/DebugString/PrimitiveSerializers/UInt2DebugStringSerializer.cs	(revision 3036)
@@ -9,5 +9,5 @@
 namespace HeuristicLab.Persistence.Default.DebugString.PrimitiveSerializers {
 
-  public class UInt2DebugStringSerializer : DebugStringSerializerBase<uint> { }
+  internal sealed class UInt2DebugStringSerializer : DebugStringSerializerBase<uint> { }
 
 }
Index: trunk/sources/HeuristicLab.Persistence/3.3/Default/DebugString/PrimitiveSerializers/ULong2DebugStringSerializer.cs
===================================================================
--- trunk/sources/HeuristicLab.Persistence/3.3/Default/DebugString/PrimitiveSerializers/ULong2DebugStringSerializer.cs	(revision 3017)
+++ trunk/sources/HeuristicLab.Persistence/3.3/Default/DebugString/PrimitiveSerializers/ULong2DebugStringSerializer.cs	(revision 3036)
@@ -9,5 +9,5 @@
 namespace HeuristicLab.Persistence.Default.DebugString.PrimitiveSerializers {
 
-  public class ULong2DebugStringSerializer : DebugStringSerializerBase<ulong> { }
+  internal sealed class ULong2DebugStringSerializer : DebugStringSerializerBase<ulong> { }
 
 }
Index: trunk/sources/HeuristicLab.Persistence/3.3/Default/DebugString/PrimitiveSerializers/UShort2DebugStringSerializer.cs
===================================================================
--- trunk/sources/HeuristicLab.Persistence/3.3/Default/DebugString/PrimitiveSerializers/UShort2DebugStringSerializer.cs	(revision 3017)
+++ trunk/sources/HeuristicLab.Persistence/3.3/Default/DebugString/PrimitiveSerializers/UShort2DebugStringSerializer.cs	(revision 3036)
@@ -9,5 +9,5 @@
 namespace HeuristicLab.Persistence.Default.DebugString.PrimitiveSerializers {
 
-  public class UShort2DebugStringSerializer : DebugStringSerializerBase<ushort> { }
+  internal sealed class UShort2DebugStringSerializer : DebugStringSerializerBase<ushort> { }
 
 }
Index: trunk/sources/HeuristicLab.Persistence/3.3/Default/DebugString/PrimitiveSerializers/ValueType2DebugStringSerializerBase.cs
===================================================================
--- trunk/sources/HeuristicLab.Persistence/3.3/Default/DebugString/PrimitiveSerializers/ValueType2DebugStringSerializerBase.cs	(revision 3017)
+++ trunk/sources/HeuristicLab.Persistence/3.3/Default/DebugString/PrimitiveSerializers/ValueType2DebugStringSerializerBase.cs	(revision 3036)
@@ -9,5 +9,5 @@
 namespace HeuristicLab.Persistence.Default.DebugString.PrimitiveSerializers {
 
-  public abstract class DebugStringSerializerBase<T> : PrimitiveSerializerBase<T, DebugString> {
+  internal abstract class DebugStringSerializerBase<T> : PrimitiveSerializerBase<T, DebugString> {
     public override DebugString Format(T o) { return new DebugString(o.ToString()); }
     public override T Parse(DebugString s) {