Index: trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Analysis/ITree.cs
===================================================================
--- trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Analysis/ITree.cs	(revision 3037)
+++ trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Analysis/ITree.cs	(revision 3038)
@@ -17,5 +17,5 @@
         /// 	<c>true</c> if this instance is directed; otherwise, <c>false</c>.
         /// </value>
-        bool IsDirected { get; set;}
+        new bool IsDirected { get; set;}
         /// <summary>
         /// Gets or sets the root of the tree
Index: trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Core/Scene graph/Model.cs
===================================================================
--- trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Core/Scene graph/Model.cs	(revision 3037)
+++ trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Core/Scene graph/Model.cs	(revision 3038)
@@ -218,6 +218,6 @@
         /// the shapes of the diagram
         /// </summary>
-        [NonSerialized]
-        private CollectionBase<IShape> mShapes;
+        //[NonSerialized]
+        //private CollectionBase<IShape> mShapes;
         /// <summary>
         /// the bounding rectangle
Index: trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Core/Scene graph/Page.cs
===================================================================
--- trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Core/Scene graph/Page.cs	(revision 3037)
+++ trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Core/Scene graph/Page.cs	(revision 3038)
@@ -34,5 +34,5 @@
         /// Occurs before an entity is transformed
         /// </summary>
-        public event EventHandler<CancelableEntityEventArgs> OnBeforeResize;
+        //public event EventHandler<CancelableEntityEventArgs> OnBeforeResize;
         #endregion
 
Index: trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Diagram elements/Connections/Connection.cs
===================================================================
--- trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Diagram elements/Connections/Connection.cs	(revision 3037)
+++ trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Diagram elements/Connections/Connection.cs	(revision 3038)
@@ -17,5 +17,5 @@
         /// </summary>
         // ------------------------------------------------------------------
-        protected const double connectionVersion = 1.0;
+        private const double connectionVersion = 1.0;
 
         #region Hack for the caps
Index: trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Diagram elements/Group/CollapsibleGroupShape.cs
===================================================================
--- trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Diagram elements/Group/CollapsibleGroupShape.cs	(revision 3037)
+++ trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Diagram elements/Group/CollapsibleGroupShape.cs	(revision 3038)
@@ -33,11 +33,4 @@
         // ------------------------------------------------------------------
         private CollectionBase<IDiagramEntity> mEntities;
-
-        // ------------------------------------------------------------------
-        /// <summary>
-        /// the bounding rectangle
-        /// </summary>
-        // ------------------------------------------------------------------
-        private Rectangle mRectangle;
 
         // ------------------------------------------------------------------
Index: trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Diagram elements/Materials/ClickableIconLabelMaterial.cs
===================================================================
--- trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Diagram elements/Materials/ClickableIconLabelMaterial.cs	(revision 3037)
+++ trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Diagram elements/Materials/ClickableIconLabelMaterial.cs	(revision 3038)
@@ -56,5 +56,5 @@
         /// </summary>
         // ------------------------------------------------------------------
-        public virtual double Version
+        public override double Version
         {
             get
Index: trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Diagram elements/Materials/ClickableIconMaterial.cs
===================================================================
--- trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Diagram elements/Materials/ClickableIconMaterial.cs	(revision 3037)
+++ trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Diagram elements/Materials/ClickableIconMaterial.cs	(revision 3038)
@@ -32,5 +32,5 @@
         /// </summary>
         // ------------------------------------------------------------------
-        public virtual double Version
+        public override double Version
         {
             get
Index: trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Diagram elements/Materials/ClickableLabelMaterial.cs
===================================================================
--- trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Diagram elements/Materials/ClickableLabelMaterial.cs	(revision 3037)
+++ trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Diagram elements/Materials/ClickableLabelMaterial.cs	(revision 3038)
@@ -50,5 +50,5 @@
         /// </summary>
         // ------------------------------------------------------------------
-        public virtual double Version
+        public override double Version
         {
             get
Index: trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Diagram elements/Materials/FolderMaterial.cs
===================================================================
--- trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Diagram elements/Materials/FolderMaterial.cs	(revision 3037)
+++ trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Diagram elements/Materials/FolderMaterial.cs	(revision 3038)
@@ -104,5 +104,5 @@
         /// </summary>
         // ------------------------------------------------------------------
-        public virtual double Version
+        public override double Version
         {
             get
Index: trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Diagram elements/Materials/IconLabelMaterial.cs
===================================================================
--- trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Diagram elements/Materials/IconLabelMaterial.cs	(revision 3037)
+++ trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Diagram elements/Materials/IconLabelMaterial.cs	(revision 3038)
@@ -56,5 +56,5 @@
         /// </summary>
         // ------------------------------------------------------------------
-        public virtual double Version
+        public override double Version
         {
             get
Index: trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Diagram elements/Materials/IconMaterial.cs
===================================================================
--- trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Diagram elements/Materials/IconMaterial.cs	(revision 3037)
+++ trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Diagram elements/Materials/IconMaterial.cs	(revision 3038)
@@ -40,5 +40,5 @@
         /// </summary>
         // ------------------------------------------------------------------
-        public virtual double Version
+        public override double Version
         {
             get
Index: trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Diagram elements/Materials/LabelMaterial.cs
===================================================================
--- trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Diagram elements/Materials/LabelMaterial.cs	(revision 3037)
+++ trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Diagram elements/Materials/LabelMaterial.cs	(revision 3038)
@@ -35,5 +35,5 @@
         /// </summary>
         // ------------------------------------------------------------------
-        public virtual double Version
+        public override double Version
         {
             get
Index: trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Diagram elements/Materials/SwitchIconMaterial.cs
===================================================================
--- trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Diagram elements/Materials/SwitchIconMaterial.cs	(revision 3037)
+++ trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Diagram elements/Materials/SwitchIconMaterial.cs	(revision 3038)
@@ -78,5 +78,5 @@
         /// </summary>
         // ------------------------------------------------------------------
-        public virtual double Version
+        public override double Version
         {
             get
Index: trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Diagram elements/Shapes/ClassShape.cs
===================================================================
--- trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Diagram elements/Shapes/ClassShape.cs	(revision 3037)
+++ trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Diagram elements/Shapes/ClassShape.cs	(revision 3038)
@@ -86,5 +86,5 @@
         /// the list of items when set to list-type
         /// </summary>
-        private ClassShapeItemCollection mList = new ClassShapeItemCollection();       
+        private CollectionBase<ClassShapeItem> mList = new CollectionBase<ClassShapeItem>();       
         /// <summary>
         /// the <see cref="LabelMaterial"/> to display the free text
@@ -226,5 +226,5 @@
         /// Gets the list of items displayed in the body
         /// </summary>
-        public ClassShapeItemCollection List
+        public CollectionBase<ClassShapeItem> List
         {
             get
Index: trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Diagram elements/Shapes/FileShape.cs
===================================================================
--- trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Diagram elements/Shapes/FileShape.cs	(revision 3037)
+++ trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Diagram elements/Shapes/FileShape.cs	(revision 3038)
@@ -281,5 +281,5 @@
             public IntPtr hIcon;
             public IntPtr iIcon;
-            public uint dwAttributes;
+            public int dwAttributes;
             [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 260)]
             public string szDisplayName;
Index: trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Diagram elements/Shapes/ShapeFactory.cs
===================================================================
--- trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Diagram elements/Shapes/ShapeFactory.cs	(revision 3037)
+++ trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Diagram elements/Shapes/ShapeFactory.cs	(revision 3038)
@@ -57,6 +57,4 @@
                     return null;
             }
-
-            return null;
         }
   
Index: trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Diagram elements/Shapes/SimpleEllipse.cs
===================================================================
--- trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Diagram elements/Shapes/SimpleEllipse.cs	(revision 3037)
+++ trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Diagram elements/Shapes/SimpleEllipse.cs	(revision 3038)
@@ -23,5 +23,5 @@
 		/// the connectors
 		/// </summary>
-		Connector cBottom, cLeft, cRight, cTop;
+    //Connector cBottom, cLeft, cRight, cTop;
 		#endregion
 
Index: trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Diagram elements/Shapes/SimpleRectangle.cs
===================================================================
--- trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Diagram elements/Shapes/SimpleRectangle.cs	(revision 3037)
+++ trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Diagram elements/Shapes/SimpleRectangle.cs	(revision 3038)
@@ -31,5 +31,5 @@
         /// </summary>
         // ------------------------------------------------------------------
-        Connector cBottom;
+        //Connector cBottom;
 
         // ------------------------------------------------------------------
@@ -38,5 +38,5 @@
         /// </summary>
         // ------------------------------------------------------------------
-        Connector cLeft;
+        //Connector cLeft;
 
         // ------------------------------------------------------------------
@@ -45,5 +45,5 @@
         /// </summary>
         // ------------------------------------------------------------------
-        Connector cRight;
+        //Connector cRight;
 
         // ------------------------------------------------------------------
@@ -52,5 +52,5 @@
         /// </summary>
         // ------------------------------------------------------------------
-        Connector cTop;
+        //Connector cTop;
 
         #endregion
Index: trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/IO/Binary/BinarySerializer.cs
===================================================================
--- trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/IO/Binary/BinarySerializer.cs	(revision 3037)
+++ trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/IO/Binary/BinarySerializer.cs	(revision 3038)
@@ -27,27 +27,21 @@
 			FileStream fs = new FileStream(fileName, FileMode.Create);
 
-			GenericFormatter<BinaryFormatter> f = new GenericFormatter<BinaryFormatter>();			
-			
-			try
-			{
-				Document document = control.Document;
-				
+			GenericFormatter<BinaryFormatter> f = new GenericFormatter<BinaryFormatter>();
 
-				//Warning!: cleaning up, you need to unhook all events since 
-                // unserializable classes hooked to events will give problems.				
-				f.Serialize<Document>(fs, document );
-				return true;
-			}			
-			catch(Exception exc)			
-			{
-				//site.OutputInfo("The graph was not saved, because some graph events were attached to non-serializable classes.\r\n This is a known issue and will be resolved in a later stadium.",OutputInfoLevels.Exception);
-				Trace.WriteLine(exc.Message, "BinarySerializer.SaveAs");
-				
-				//DumpInfo();
-			}
-			catch
-			{
-				Trace.WriteLine("Non-CLS exception caught.","BinarySerializer.SaveAs");
-			}
+      try {
+        Document document = control.Document;
+
+
+        //Warning!: cleaning up, you need to unhook all events since 
+        // unserializable classes hooked to events will give problems.				
+        f.Serialize<Document>(fs, document);
+        return true;
+      }
+      catch (Exception exc) {
+        //site.OutputInfo("The graph was not saved, because some graph events were attached to non-serializable classes.\r\n This is a known issue and will be resolved in a later stadium.",OutputInfoLevels.Exception);
+        Trace.WriteLine(exc.Message, "BinarySerializer.SaveAs");
+
+        //DumpInfo();
+      }
 			finally
 			{
@@ -117,9 +111,4 @@
                 MessageBox.Show(exc.Message, "BinarySerializer.Open");
 			}
-			catch
-			{
-                MessageBox.Show("Non-CLS exception caught.", "BinarySerializer.Open");
-				
-			}
 			finally
 			{
Index: trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Layout/BalloonTreeLayout.cs
===================================================================
--- trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Layout/BalloonTreeLayout.cs	(revision 3037)
+++ trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Layout/BalloonTreeLayout.cs	(revision 3038)
@@ -230,6 +230,6 @@
             public int d;
             public int r;
-            public double rx;
-            public double ry;
+            //public double rx;
+            //public double ry;
             public double a;
             public double c;
Index: trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446.csproj
===================================================================
--- trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446.csproj	(revision 3037)
+++ trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446.csproj	(revision 3038)
@@ -85,5 +85,6 @@
     <BaseAddress>285212672</BaseAddress>
     <CheckForOverflowUnderflow>true</CheckForOverflowUnderflow>
-    <DocumentationFile>bin\Debug\Netron Documentation.xml</DocumentationFile>
+    <DocumentationFile>
+    </DocumentationFile>
     <FileAlignment>4096</FileAlignment>
     <DebugType>full</DebugType>
Index: trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Printing/DiagramPrinter.cs
===================================================================
--- trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Printing/DiagramPrinter.cs	(revision 3037)
+++ trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Printing/DiagramPrinter.cs	(revision 3038)
@@ -19,5 +19,5 @@
         PrintDocument myDocument;
         IDiagramControl myDiagram;
-        PrinterSettings mySettings;
+        //PrinterSettings mySettings;
         PageSettings myPageSettings;
         int currentPageIndex = 0;
Index: trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Serialization/Connection.Serialization.cs
===================================================================
--- trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Serialization/Connection.Serialization.cs	(revision 3037)
+++ trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Serialization/Connection.Serialization.cs	(revision 3038)
@@ -22,5 +22,5 @@
         /// <param name="info">The info.</param>
         /// <param name="context">The context.</param>
-        protected Connection(SerializationInfo info, StreamingContext context) : base(info, context)
+        private Connection(SerializationInfo info, StreamingContext context) : base(info, context)
         {
             if(Tracing.BinaryDeserializationSwitch.Enabled)
Index: trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Tools/HotKeys.cs
===================================================================
--- trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Tools/HotKeys.cs	(revision 3037)
+++ trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Tools/HotKeys.cs	(revision 3038)
@@ -33,5 +33,4 @@
         public void KeyUp(System.Windows.Forms.KeyEventArgs e)
         {
-            ICommand cmd = null;
             switch (e.KeyCode)
             {